#if !defined(H_MACROS_H)
	#define H_MACROS_H

#define ONFAIL(X,E) if (FAILED(X)) return (E)
#define ONFAILR(X) do { HRESULT t_h=(X); if (FAILED(t_h)) return (t_h); } while (0)
#define ONFAILGO(X,V,G) do { V=(X); if (FAILED(V)) goto G; } while (0)
#define EXPECT(X) ONFAIL((X),E_UNEXPECTED)


#define IOUT(X) __uuidof(*(X)), reinterpret_cast<void**>(X)

#endif
