// InputSummand.h: Definition of the InputSummand class
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INPUTSUMMAND_H__E184BD0E_8398_4C56_B616_C9B9DF07F334__INCLUDED_)
#define AFX_INPUTSUMMAND_H__E184BD0E_8398_4C56_B616_C9B9DF07F334__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"       // main symbols

#include "DebugRefCount.h"

/////////////////////////////////////////////////////////////////////////////
// InputSummand

class InputSummand : 
	public IOTConnector,
	public IOTConnectorDescribe,
	public IOTInput,
	public CComObjectRoot,
	public CComCoClass<InputSummand,&CLSID_InputSummand>
{
private:
	CComPtr<IOTOutput> m_spIOTOutputInput;	// A pointer to our input

public:
	InputSummand() { }

BEGIN_COM_MAP(InputSummand)
	COM_INTERFACE_ENTRY(IOTConnector)
	COM_INTERFACE_ENTRY(IOTConnectorDescribe)
	COM_INTERFACE_ENTRY(IOTInput)
END_COM_MAP()

DECLARE_REGISTRY_RESOURCEID(IDR_InputSummand)
DECLARE_GET_CONTROLLING_UNKNOWN()
DECLARE_PROTECT_FINAL_CONSTRUCT()

_DEBUG_REFCOUNT_IMPL(InputSummand,CComSingleThreadModel)

public:

// IOTConnector
	STDMETHOD(OpenTool)(/*[out]*/ IOpenTool** a_ppIOpenTool);
	STDMETHOD(ConnectorType)();

// IOTConnectorDescribe
	STDMETHOD(ConnectorName)(/*[out,string]*/ wchar_t** a_pwsName,/*[out,string]*/ wchar_t** a_pwsAliases);
	STDMETHOD(ConnectorDescription)(/*[out,string]*/ wchar_t** a_pwsDescription);

// IOTInput
	HRESULT Compatibility(IOTConnector*);	// Return the compatibility code for supplied connector
	STDMETHOD(Connect)(IOTConnector* a_pIOTConnector);	// Supply input connector - which must also supprt IOTOutput
	STDMETHOD(Input)(/*[out]*/ IOTConnector** a_ppIOTConnector);
};

#endif // !defined(AFX_INPUTSUMMAND_H__E184BD0E_8398_4C56_B616_C9B9DF07F334__INCLUDED_)
