// OutputSum.h: Definition of the OutputSum class
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OUTPUTSUM_H__FDC14A8C_1CA2_47BB_9766_70C453501035__INCLUDED_)
#define AFX_OUTPUTSUM_H__FDC14A8C_1CA2_47BB_9766_70C453501035__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"       // main symbols

#include "DebugRefCount.h"

#include "InputSummand.h"


/////////////////////////////////////////////////////////////////////////////
// OutputSum

class OutputSum : 
	public IOTConnector,
	public IOTConnectorDescribe,
	public IOTOutput,
	public IEgOTConnectSum,
	public IOTDataVector,
	public IEgOTDataOptReal,
	public CComObjectRoot,
	public CComCoClass<OutputSum,&CLSID_OutputSum>
{
public:
	OutputSum() {}
BEGIN_COM_MAP(OutputSum)
	COM_INTERFACE_ENTRY(IOTConnector)
	COM_INTERFACE_ENTRY(IOTConnectorDescribe)
	COM_INTERFACE_ENTRY(IOTOutput)
	COM_INTERFACE_ENTRY(IEgOTConnectSum)
	COM_INTERFACE_ENTRY(IOTDataVector)
	COM_INTERFACE_ENTRY(IEgOTDataOptReal)
END_COM_MAP()

DECLARE_REGISTRY_RESOURCEID(IDR_OutputSum)
DECLARE_GET_CONTROLLING_UNKNOWN()
DECLARE_PROTECT_FINAL_CONSTRUCT()

_DEBUG_REFCOUNT_IMPL(OutputSum,CComSingleThreadModel)


public:
// IOTConnector
	STDMETHOD(OpenTool)(IOpenTool** a_ppIOpenTool);
	STDMETHOD(ConnectorType)();

// IOTConnectorDescribe
	STDMETHOD(ConnectorName)(/*[out,string]*/ wchar_t** a_pwsName,/*[out,string]*/ wchar_t** a_pwsAliases);
	STDMETHOD(ConnectorDescription)(/*[out,string]*/ wchar_t** a_pwsDescription);


// IOTOutput
	STDMETHOD(Status)();
	STDMETHOD(Changes)(/*[in,out]*/ index* a_piState);

// IEgOTConnectSum

// IOTDataVector
	STDMETHOD(Nature)();
	STDMETHOD(Vector)(/*[out,size_is(a_uBufferLength),length_is(*a_puReturned)]*/ real* a_prBuffer,unsigned a_uBufferLength,/*[out]*/ index* a_piStart,/*[out]*/ unsigned* a_puReturned,/*[out]*/ index* a_piRemain);

// IEgOTDataOptReal
	STDMETHOD(EgOptNature)();
	STDMETHOD(EgOptReal)(/*[out]*/ real* a_prValue);

};

#endif // !defined(AFX_OUTPUTSUM_H__FDC14A8C_1CA2_47BB_9766_70C453501035__INCLUDED_)
