// StubReal.h: Definition of the StubReal class
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STUBREAL_H__7F473F1E_A2B1_4BE7_903F_886B102F85B1__INCLUDED_)
#define AFX_STUBREAL_H__7F473F1E_A2B1_4BE7_903F_886B102F85B1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"       // main symbols

#include "DebugRefCount.h"

/////////////////////////////////////////////////////////////////////////////
// StubReal

class StubReal : 
	public IOpenTool,
	public IOTDescribe,
	public IOTConnector,
	public IOTConnectorDescribe,
	public IOTOutput,
	public IOTDataVector,
	public IEgOTDataOptReal,
	public CComObjectRoot,
	public CComCoClass<StubReal,&CLSID_StubReal>
{
public:
	StubReal() {}
BEGIN_COM_MAP(StubReal)
	COM_INTERFACE_ENTRY(IOpenTool)
	COM_INTERFACE_ENTRY(IOTDescribe)
	COM_INTERFACE_ENTRY(IOTConnector)
	COM_INTERFACE_ENTRY(IOTConnectorDescribe)
	COM_INTERFACE_ENTRY(IOTOutput)
	COM_INTERFACE_ENTRY(IOTDataVector)
	COM_INTERFACE_ENTRY(IEgOTDataOptReal)
END_COM_MAP()

DECLARE_REGISTRY_RESOURCEID(IDR_StubReal)
DECLARE_GET_CONTROLLING_UNKNOWN()
DECLARE_PROTECT_FINAL_CONSTRUCT()

_DEBUG_REFCOUNT_IMPL(StubReal,CComSingleThreadModel)

public:	// All methods are of a read/access/get nature unless verb indicates otherwise

// IOpenTool

// IOTDescribe
	STDMETHOD(Name)(/*[out,string]*/ wchar_t** a_pwsName,/*[out,string]*/ wchar_t** a_pwsAliases);
	STDMETHOD(Class)(/*[out,string]*/ wchar_t** a_pwsClass,/*[out,string]*/ wchar_t** a_pwsAliases);
	STDMETHOD(Description)(/*[out,string]*/ wchar_t** a_pwsDescription);

// IOTConnector
	STDMETHOD(OpenTool)(/*[out]*/ IOpenTool** a_ppIOpenTool);
	STDMETHOD(ConnectorType)();

// IOTConnectorDescribe
	STDMETHOD(ConnectorName)(/*[out,string]*/ wchar_t** a_pwsName,/*[out,string]*/ wchar_t** a_pwsAliases);
	STDMETHOD(ConnectorDescription)(/*[out,string]*/ wchar_t** a_pwsDescription);

// IOTOutput
	STDMETHOD(Status)();
	STDMETHOD(Changes)(/*[in,out]*/ index* a_piState);

// IOTDataVector
	STDMETHOD(Nature)();
	STDMETHOD(Vector)(/*[out,size_is(a_uBufferLength),length_is(*a_puReturned)]*/ real* a_prBuffer,unsigned a_uBufferLength,/*[out]*/ index* a_piStart,/*[out]*/ unsigned* a_puReturned,/*[out]*/ index* a_piRemain);

// IEgOTDataOptReal
	STDMETHOD(EgOptNature)();
	STDMETHOD(EgOptReal)(/*[out]*/ real* a_prValue);

};

#endif // !defined(AFX_STUBREAL_H__7F473F1E_A2B1_4BE7_903F_886B102F85B1__INCLUDED_)
